//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "StatisticsUnit.h"
#include "display\ValueStringFormatter.h"
#include "device\Data.h"
#include "Utilities.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmStatistics *frmStatistics;
//---------------------------------------------------------------------------
__fastcall TfrmStatistics::TfrmStatistics(TComponent* Owner)
	: TfrmCommon(Owner)
{
}
//---------------------------------------------------------------------------

void TfrmStatistics::Process(const Data &data, int channel, float fDivX)
{
	if (const_cast<Data&>(data).getChannel(channel).dataOsc.empty())
		return;
	/** \todo spectrum, osc -> dataOsc, recorder -> dataRec? */
	AnsiString title = _("Ch. %s stats");
	this->Caption.sprintf(title.c_str(), GetChannelName(channel).c_str());
	statistics.Process(data, channel, fDivX);
	lblValMin->Caption = ValueStringFormatter::VoltageToStr(statistics.fMin, 3).c_str();
	lblValMax->Caption = ValueStringFormatter::VoltageToStr(statistics.fMax, 3).c_str();
	lblValPp->Caption = ValueStringFormatter::VoltageToStr(statistics.fMax-statistics.fMin, 3).c_str();
	lblValAvg->Caption = ValueStringFormatter::VoltageToStr(statistics.fAvg, 3).c_str();
	lblValRms->Caption = ValueStringFormatter::VoltageToStr(statistics.fRms, 3).c_str();
	if (statistics.bFreqValid)
		lblFreqVal->Caption = ValueStringFormatter::FreqToStr(statistics.fFreq, 3).c_str();
	else
		lblFreqVal->Caption = "----";
}

